#ifndef HWINIT_H
#define HWINIT_H

void HW_Init( void );




//--- PORT 1 --------------------------------------------------------------------------------------------------------------------
#define OPTO1_IN        BIT0
#define OPTO2_IN        BIT1
#define OPTO_ENABLE     BIT2
#define UART0_RX_IRQ    BIT3
#define SUB_BOARD_18    BIT4
#define SUB_BOARD_17    BIT5
#define SUB_BOARD_16    BIT6
#define SUB_BOARD_15    BIT7
/*-------------------------------------------------------------------------------------------------------------------------------
P1.0 | OPTO1_IN     | DIR = IN  [0] |  OUT = LOW [0] | SEL = GPIO [0] | IE = DISABLE [0] | IES = RISING EDGE [0] | IFG = CLEAR [0]
P1.1 | OPTO2_IN     | DIR = IN  [0] |  OUT = LOW [0] | SEL = GPIO [0] | IE = DISABLE [0] | IES = RISING EDGE [0] | IFG = CLEAR [0]
P1.2 | OPTO_ENABLE  | DIR = OUT [1] |  OUT = LOW [0] | SEL = GPIO [0] | IE = DISABLE [0] | IES = RISING EDGE [0] | IFG = CLEAR [0]
P1.3 | UART0_RX_IRQ | DIR = IN  [0] |  OUT = LOW [0] | SEL = GPIO [0] | IE = DISABLE [0] | IES = RISING EDGE [0] | IFG = CLEAR [0]
P1.4 | SUB_BOARD_18 | DIR = IN  [0] |  OUT = LOW [0] | SEL = GPIO [0] | IE = DISABLE [0] | IES = RISING EDGE [0] | IFG = CLEAR [0]
P1.5 | SUB_BOARD_17 | DIR = IN  [0] |  OUT = LOW [0] | SEL = GPIO [0] | IE = DISABLE [0] | IES = RISING EDGE [0] | IFG = CLEAR [0]
P1.6 | SUB_BOARD_16 | DIR = IN  [0] |  OUT = LOW [0] | SEL = GPIO [0] | IE = DISABLE [0] | IES = RISING EDGE [0] | IFG = CLEAR [0]
P1.7 | SUB_BOARD_15 | DIR = IN  [0] |  OUT = LOW [0] | SEL = GPIO [0] | IE = DISABLE [0] | IES = RISING EDGE [0] | IFG = CLEAR [0]
--------------------------------------------------------------------------------------------------------------------------------*/        
#define P1SEL_INIT  0x00
#define P1DIR_INIT  OPTO_ENABLE
#define P1OUT_INIT  0x00
#define P1IES_INIT  0x00
#define P1IFG_INIT  0x00
#define P1IE_INIT   0x00
//-------------------------------------------------------------------------------------------------------------------------------


//--- PORT 2 --------------------------------------------------------------------------------------------------------------------
#define NRF_TX_EN       BIT0
#define NRF_TRX_CE      BIT1
#define NRF_CD          BIT2
#define NRF_AM          BIT3
#define NRF_DR          BIT4
#define P3V0RF_EN       BIT5
#define MAX3222_PWR_UP  BIT6
#define MAX3222_SHDN    BIT7
/*---------------------------------------------------------------------------------------------------------------------------------
P2.0 | NRF_TX_EN      | DIR = OUT [1] |  OUT = LOW [0] | SEL = GPIO [0] | IE = DISABLE [0] | IES = RISING EDGE [0] | IFG = CLEAR [0]
P2.1 | NRF_TRX_CE     | DIR = OUT [1] |  OUT = LOW [0] | SEL = GPIO [0] | IE = DISABLE [0] | IES = RISING EDGE [0] | IFG = CLEAR [0]
P2.2 | NRF_CD         | DIR = IN  [0] |  OUT = LOW [0] | SEL = GPIO [0] | IE = DISABLE [0] | IES = RISING EDGE [0] | IFG = CLEAR [0]
P2.3 | NRF_AM         | DIR = IN  [0] |  OUT = LOW [0] | SEL = GPIO [0] | IE = DISABLE [0] | IES = RISING EDGE [0] | IFG = CLEAR [0]
P2.4 | NRF_DR         | DIR = IN  [0] |  OUT = LOW [0] | SEL = GPIO [0] | IE = DISABLE [0] | IES = RISING EDGE [0] | IFG = CLEAR [0]
P2.5 | P3V0RF_EN      | DIR = OUT [1] |  OUT = HIGH[1] | SEL = GPIO [0] | IE = DISABLE [0] | IES = RISING EDGE [0] | IFG = CLEAR [0]
P2.6 | MAX3222_PWR_UP | DIR = OUT [1] |  OUT = HIGH[1] | SEL = GPIO [0] | IE = DISABLE [0] | IES = RISING EDGE [0] | IFG = CLEAR [0]
P2.7 | MAX3222_SHDN   | DIR = OUT [1] |  OUT = LOW [0] | SEL = GPIO [0] | IE = DISABLE [0] | IES = RISING EDGE [0] | IFG = CLEAR [0]
----------------------------------------------------------------------------------------------------------------------------------*/        
#define P2SEL_INIT  0x00
#define P2DIR_INIT  NRF_TX_EN + NRF_TRX_CE + P3V0RF_EN + MAX3222_PWR_UP + MAX3222_SHDN
#define P2OUT_INIT  P3V0RF_EN + MAX3222_PWR_UP
#define P2IES_INIT  0x00
#define P2IFG_INIT  0x00
#define P2IE_INIT   0x00
//-------------------------------------------------------------------------------------------------------------------------------


//--- PORT 3 --------------------------------------------------------------------------------------------------------------------
#define LED0            BIT0
#define LED1            BIT1
#define LED2            BIT2
#define LED3            BIT3
#define UTXD0           BIT4
#define URXD0           BIT5
#define SWITCH_ENABLE   BIT7
/*---------------------------------------------------------------------
P3.0 | LED0          | DIR = OUT [1] |  OUT = HIGH [1] | SEL = GPIO [0]  
P3.1 | LED1          | DIR = OUT [1] |  OUT = HIGH [1] | SEL = GPIO [0]  
P3.2 | LED2          | DIR = OUT [1] |  OUT = HIGH [1] | SEL = GPIO [0]  
P3.3 | LED3          | DIR = OUT [1] |  OUT = HIGH [1] | SEL = GPIO [0]  
P3.4 | UTXD0         | DIR = OUT [1] |  OUT = LOW  [0] | SEL = UART0[1]  
P3.5 | URXD0         | DIR = IN  [0] |  OUT = LOW  [0] | SEL = UART0[1]  
P3.6 | UNUSED        | DIR = IN  [0] |  OUT = LOW  [0] | SEL = GPIO [0]  
P3.7 | SWITCH_ENABLE | DIR = OUT [1] |  OUT = LOW  [0] | SEL = GPIO [0]  
---------------------------------------------------------------------*/
#define P3SEL_INIT  UTXD0 + URXD0
#define P3DIR_INIT  LED0 + LED1 + LED2 + LED3 + UTXD0 + SWITCH_ENABLE
#define P3OUT_INIT  LED0 + LED1 + LED2 + LED3
//-------------------------------------------------------------------------------------------------------------------------------


//--- PORT 4 --------------------------------------------------------------------------------------------------------------------
#define SWITCH0         BIT0
#define SWITCH1         BIT1
#define SWITCH2         BIT2
#define SWITCH3         BIT3
#define SWITCH4         BIT4
#define SWITCH5         BIT5
#define SWITCH6         BIT6
#define SWITCH7         BIT7
/*------------------------------------------------------------
P4.0 | SWITCH0 | DIR = IN [0] |  OUT = LOW [0] | SEL = GPIO [0]  
P4.1 | SWITCH1 | DIR = IN [0] |  OUT = LOW [0] | SEL = GPIO [0]  
P4.2 | SWITCH2 | DIR = IN [0] |  OUT = LOW [0] | SEL = GPIO [0]  
P4.3 | SWITCH3 | DIR = IN [0] |  OUT = LOW [0] | SEL = GPIO [0]  
P4.4 | SWITCH4 | DIR = IN [0] |  OUT = LOW [0] | SEL = GPIO [0]  
P4.5 | SWITCH5 | DIR = IN [0] |  OUT = LOW [0] | SEL = GPIO [0]  
P4.6 | SWITCH6 | DIR = IN [0] |  OUT = LOW [0] | SEL = GPIO [0]  
P4.7 | SWITCH7 | DIR = IN [0] |  OUT = LOW [0] | SEL = GPIO [0]  
-------------------------------------------------------------*/
#define P4SEL_INIT  0x00
#define P4DIR_INIT  0x00
#define P4OUT_INIT  0x00
//-------------------------------------------------------------------------------------------------------------------------------


//--- PORT 5 --------------------------------------------------------------------------------------------------------------------
#define NRF_CSN         BIT0    
#define SPI1_SIMO       BIT1    
#define SPI1_MOSI       BIT2    
#define SPI1_UCLK       BIT3    
#define NRF_PWRUP       BIT4    
#define NCP1400_ENABLE  BIT5
#define BUZZER          BIT6
#define P5V0D_ENABLE    BIT7
/*-------------------------------------------------------------------
P5.0 | NRF_CSN        | DIR = OUT[1] |  OUT = LOW [0] | SEL = GPIO [0]  
P5.1 | SPI1_SIMO      | DIR = OUT[1] |  OUT = LOW [0] | SEL = SPI1 [1]  
P5.2 | SPI1_MOSI      | DIR = IN [0] |  OUT = LOW [0] | SEL = SPI1 [1]  
P5.3 | SPI1_UCLK      | DIR = OUT[1] |  OUT = LOW [0] | SEL = SPI1 [1]  
P5.4 | NRF_PWRUP      | DIR = OUT[1] |  OUT = LOW [0] | SEL = GPIO [0]  
P5.5 | NCP1400_ENABLE | DIR = OUT[1] |  OUT = LOW [0] | SEL = GPIO [0]  
P5.6 | BUZZER         | DIR = OUT[1] |  OUT = LOW [0] | SEL = GPIO [0]  
P5.7 | P5V0D_ENABLE   | DIR = OUT[1] |  OUT = LOW [0] | SEL = GPIO [0]  
--------------------------------------------------------------------*/
#define P5SEL_INIT  SPI1_SIMO + SPI1_MOSI + SPI1_UCLK
#define P5DIR_INIT  NRF_CSN + SPI1_SIMO + SPI1_UCLK + NRF_PWRUP + NCP1400_ENABLE + BUZZER + P5V0D_ENABLE
#define P5OUT_INIT  0x00
//-------------------------------------------------------------------------------------------------------------------------------


//--- PORT 6 --------------------------------------------------------------------------------------------------------------------
#define CLEAR_RELAY1        BIT0
#define SET_RELAY1          BIT1
#define CLEAR_RELAY2        BIT2
#define SET_RELAY2          BIT3
#define SUB_BOARD_19        BIT4
#define SUB_BOARD_20        BIT5
#define SUPPLY_MEAS_ENABLE  BIT6
#define SUPPLY_VOLTAGE      BIT7
/*------------------------------------------------------------------------
P6.0 | CLEAR_RELAY1       | DIR = OUT[1] |  OUT = LOW [0] | SEL = GPIO [0]  
P6.1 | SET_RELAY1         | DIR = OUT[1] |  OUT = LOW [0] | SEL = GPIO [0]  
P6.2 | CLEAR_RELAY2       | DIR = OUT[1] |  OUT = LOW [0] | SEL = GPIO [0]  
P6.3 | SET_RELAY2         | DIR = OUT[1] |  OUT = LOW [0] | SEL = GPIO [0]  
P6.4 | SUB_BOARD_19       | DIR = IN [0] |  OUT = LOW [0] | SEL = GPIO [0]  
P6.5 | SUB_BOARD_20       | DIR = IN [0] |  OUT = LOW [0] | SEL = GPIO [0]  
P6.6 | SUPPLY_MEAS_ENABLE | DIR = OUT[1] |  OUT = HIGH[1] | SEL = GPIO [0]  
P6.7 | SUPPLY_VOLTAGE     | DIR = IN [0] |  OUT = LOW [0] | SEL = GPIO [0]  
-------------------------------------------------------------------------*/
#define P6SEL_INIT  SUPPLY_VOLTAGE
#define P6DIR_INIT  CLEAR_RELAY1 + SET_RELAY1 + CLEAR_RELAY2 + SET_RELAY2 + SUPPLY_MEAS_ENABLE
#define P6OUT_INIT  SUPPLY_MEAS_ENABLE
//-------------------------------------------------------------------------------------------------------------------------------

   
//--- TIMER A -------------------------------------------------------------------------------------------------------------------
#define TIMER_A_TICK    100

//--- UART 0 --------------------------------------------------------------------------------------------------------------------




#endif
