// ##      ##  ##########  ##########        ##########  ####
// ##  ##  ##  ##      ##  ##  ##  ##        ##            ##
// ##  ##  ##  #####   ##  ##  ##  ##  ####  ##########    ##
// ##  ##  ##  ##      ##  ##      ##                ##    ## 
// ##########  ##      ##  ##      ##        ##########    ##


#include <msp430x14x.h>
#include "osc.h"
#include "physical.h"
#include "defs.h"
#include "hwinit.h"
#include "modem.h"
#include "uart.h"
#include "network.h"
#include "application.h"
#include "timer_a.h"
#include "led.h"

const char ccTestStream[]=  "WAM-S1 TEST STREAM IT WILL TESTING ROUTING, MAC AND PHY ";

main( void )
{
    unsigned int i=0;
    
    HW_Init( ); 
    __enable_interrupt( );
    
    NRF_SetPwrMode( STANDBY );
    SetHiSpeedOsc( );
    NRF_Init( );
    InitTimerA( );
    StartUart0( BR_115200 );

    Application( );
    

    //*** Debugg only << Continous TX  in autoretrans >>
    //    NRF_SetPwrMode( FULL_POWER );
    //    SET_BITS( P2OUT, NRF_TX_EN );
    //    SET_BITS( P2OUT, NRF_TRX_CE );
    //***



    while( 1){
        if( i++ < 1000 )
            LED_SetLed( LED0 );
        else
            LED_ClearLed( LED0 );
        if( i > 30000 )
            i = 0;
            
            
    }
}


//------------------------------------------------------------------------
// END OF FILE
//------------------------------------------------------------------------
