#include <msp430x14x.h>
#include "defs.h"
#include "nrf905.h"

void InitOsc( void )
{
    unsigned char i;
    // start with low speed oscilatior ( 32.768kHz )
    BCSCTL1 = XT2OFF;                 // disable XT2, LFXT1 operates as high frequency osc.
    do{
        CLEAR_BITS( IFG1, OFIFG );    // Clear OSCFault flag
        for (i = 0xFF; i > 0; i--);   // Time for flag to set
    }
    while ( (IFG1 & OFIFG) );         // OSCFault flag still set?                
    BCSCTL2 = SELM_3;                 // MCLK = LFXT1 Clock
}


void SetHiSpeedOsc( void )
{
    unsigned char i;
    
    uNrfConfigReg.uNrfConfigBf.Nrf905UpClkFreq = NRF_4MHZ_EXT_CLK; 
    uNrfConfigReg.uNrfConfigBf.Nrf905UpClkEn = NRF_UP_CLK_EN;
    NRF_Init( );

  CLEAR_BITS( BCSCTL1, XT2OFF );        // XT2= HF XTAL
  do{
      CLEAR_BITS( IFG1, OFIFG );        // Clear OSCFault flag
      for (i = 0xFF; i > 0; i--);       // Time for flag to set
  }
  while ( ( IFG1 & OFIFG ) );           // OSCFault flag still set?                
  BCSCTL2 = SELM_2 + SELS;              // MCLK = SMCLK = XT2 (safe)
}


void SetLowSpeedOsc( void )
{
    BCSCTL2 = SELM_3;                   // MCLK = LFXT1 Clock, disable SMCLK
    SET_BITS( BCSCTL1, XT2OFF );        // stop XT2 oscillator
    uNrfConfigReg.uNrfConfigBf.Nrf905UpClkFreq = NRF_500KHZ_EXT_CLK; 
    uNrfConfigReg.uNrfConfigBf.Nrf905UpClkEn = NRF_UP_CLK_DIS;
    NRF_Init( );
}








