#include <msp430x14x.h>
#include "defs.h"
#include "transport.h"
#include "transframe.h"
#include "network.h"

#define MY_ADDRESS 0x55555555

t_TransFrame sTransFrame;    

void TPL_Tx( unsigned long ulAddress, unsigned int uiCommand, unsigned char *pData, unsigned char ucDataLength )
{
    unsigned char ucPayLoadRest;
    unsigned char ucPayLoadIndex;
    unsigned char ucRouteSuccess = TRUE;
    
    sTransFrame.ulOrigAddr = MY_ADDRESS;
    sTransFrame.ulDestAddr = ulAddress;
    sTransFrame.uiCommand = uiCommand;
    
    //-- calc number of neccassary frames to transmitt this message
    sTransFrame.sFrmCtl.ucFrmCnt = ucDataLength / DATA_PAYLOAD_SIZE;
    if( !( sTransFrame.sFrmCtl.ucFrmCnt == ( ucDataLength * DATA_PAYLOAD_SIZE ) ) ){
        ucPayLoadRest = ucDataLength - ( sTransFrame.sFrmCtl.ucFrmCnt * DATA_PAYLOAD_SIZE );
        sTransFrame.sFrmCtl.ucFrmCnt++;
    }
    else{
        ucPayLoadRest = 0;
    }
    //-- build frame and get it down to the network layer
    while( sTransFrame.sFrmCtl.ucFrmCnt && ucRouteSuccess ){
        //-- load data payload length
        if( sTransFrame.sFrmCtl.ucFrmCnt > 1 ){  // full data paylaod 
            sTransFrame.ucDataLength = DATA_PAYLOAD_SIZE;
            for( ucPayLoadIndex = 0; ucPayLoadIndex < DATA_PAYLOAD_SIZE; ucPayLoadIndex++ ){
                sTransFrame.aucDataPayLoad[ ucPayLoadIndex ] = *pData;
                pData++;
            } 
        }
        else{                                    // size of rest of data
            if( ucPayLoadRest ){
                for( ucPayLoadIndex = 0; ucPayLoadIndex < ucPayLoadRest; ucPayLoadIndex++ ){
                    sTransFrame.aucDataPayLoad[ ucPayLoadIndex ] = *pData;
                    pData++;
                } 
                sTransFrame.ucDataLength = ucPayLoadRest;
            }
        }        
        //-- reset frame repeat counter
        sTransFrame.sFrmCtl.ucFrmRep = 0;   
        //-- reset "time to life" counter
        sTransFrame.ucTTL = 0;
        //-- call router
        ucRouteSuccess = NWL_Route( &sTransFrame );
        //-- decrement frame number
        sTransFrame.sFrmCtl.ucFrmCnt--;         
    }
}


